/*****************************************************************************
*                                                                            *
*   Home Finance Database System.                                            *
*   Keep track of your money and have easy access to finding data.           *
*                                                                            *
*   Originally developed on Linux                                            *
*                                                                            *
*   Author: Peter Leif Rasmussen, 1997                                       *
*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include<unistd.h>
#include"finance.h"

extern int check_descr(char *, opt_unit *);
extern void print_options(opt_unit *);

extern rec_unit *finance, *finance_end;
extern int item,changed;

void edit_data(opt_unit *check_list)
{
char temp[1000];
int id,lets_go=0,old_strlen;
rec_unit *temp_point;
char *empty;

if(!(empty=(char *)calloc(100,1))) 
	{
	fprintf(stderr,"Couldn't allocate 100B, please use default file-name\n");
	return;
	}

if(item==0) {printf("No data has been entered or loaded!\n"); return;}

do {
   printf("Please enter the ID number of the record you wish to edit: ");
   fflush(stdout);
   fgets(temp,1000,stdin);
   id=atoi(temp);
   } while(id>item && id<0);

temp_point=finance;

while(temp_point->ID!=id)
	temp_point=temp_point->next_rec;

printf("The following is the record with ID = %d, as it stands now:\n\n",id);
printf("Date:\t\t%d-%d-%d\n",temp_point->year,temp_point->month,temp_point->day);
printf("Description:\t%s\n",temp_point->description);
printf("Income:\t\t%6.2f\n",temp_point->income);
printf("Credit-C:\t%6.2f\n",temp_point->credit);
printf("Cash:\t\t%6.2f\n\n",temp_point->cash);

printf("Do you wish to edit this record?  (y/n) : "); fflush(stdout);
fgets(temp,1000,stdin);
if(temp[0]=='n') return;

  lets_go=0;
  do{
    printf("Please enter the year [%d]: ",temp_point->year);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->year=atoi(temp);changed=1;}

    printf("Please enter the month [%d]: ",temp_point->month);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->month=atoi(temp);changed=1;}

    printf("Please enter the day [%d]: ",temp_point->day);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->day=atoi(temp);changed=1;}

    printf("Is this date OK? \"%d-%d-%d\"  (y/n) :  ",
            temp_point->year,temp_point->month,temp_point->day);
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)==1 || temp[0]=='y') lets_go=1;

    } while(temp_point->year>3000 || temp_point->year<0 || temp_point->month>11 
           || temp_point->month<0 || temp_point->day>31 || temp_point->day<1
           || lets_go==0);
  do{
    printf("\nThe old description:\t%s\n",temp_point->description);
    printf("Enter a new description (\"?\" to see approved list) : "); 
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(temp[0]=='?') print_options(check_list);
    } while (check_descr(temp,check_list) && strlen(temp)!=1);

old_strlen=strlen(temp_point->description);

if(strlen(temp)>1)
  {
  strncpy(temp_point->description,empty,old_strlen);

  temp_point->descr_length=strlen(temp)-1;
  temp_point->description=(char *)realloc(temp_point->description,temp_point->descr_length+1);
  if(temp_point->description==NULL) fprintf(stderr,"description malloc error, temp_point->descr_length=%d\n",temp_point->descr_length);
  strncpy(temp_point->description,temp,temp_point->descr_length);
  strcat(temp_point->description,"\0");
  changed=1;
  }

  do{
    printf("\nEnter the new amount of cash used [%6.2f]: ",temp_point->cash); 
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->cash=atof(temp);changed=1;}
    } while(temp_point->cash<0.0 || temp_point->cash>10000.0);

  do{
    printf("Enter the new amount of credit card used [%6.2f]: ",temp_point->credit); 
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->credit=atof(temp);changed=1;}
    } while(temp_point->credit<0.0 || temp_point->credit>10000.0);

  do{
    printf("Enter the new amount of income [%6.2f]: ",temp_point->income); 
    fflush(stdout);
    fgets(temp,1000,stdin);
    if(strlen(temp)!=1) {temp_point->income=atof(temp);changed=1;}
    } while(temp_point->income<0.0 || temp_point->income>100000.0);

printf("The record now stands as:\n\n");
printf("ID:\t\t%d\n",id);
printf("Date:\t\t%d-%d-%d\n",temp_point->year,temp_point->month,temp_point->day);
printf("Description:\t%s\n",temp_point->description);
printf("Income:\t\t%6.2f\n",temp_point->income);
printf("Credit-C:\t%6.2f\n",temp_point->credit);
printf("Cash:\t\t%6.2f\n\n",temp_point->cash);
printf("Press <Enter> to continue");fflush(stdout);
gets(temp);
}
